###############################################################################
# ManagePortal.pl                                                             #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.3                                        #
# Released:       December 2001; Updated April 6, 2003                        #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2003 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# ManagePortal.pl by Daniel Alm.                                              #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
###############################################################################

$manageportalplver = "1.00";

sub ModifyPortalTemplate {
	&is_admin;
	my( $fulltemplate, $line );
	$yymain .= qq~
<table border=0 width="100%" cellspacing=1 class="bordercolor" cellpadding="4">
  <tr>
    <td class="titlebg">
    <img src="$imagesdir/xx.gif" alt="" border="0">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$portal{'01'}</b></font></td>
  </tr><tr>
    <td class="windowbg">
    <font size=2>$portal{'template02'}</font></td>
  </tr><tr>
	<form action="$cgi;action=modportaltemp" method="POST">
    <td class="windowbg2" align="center">
    <font size="1">
	<select name="template">~;
    opendir(DIR,".");
    @files = readdir(DIR);
    closedir(DIR);

    chomp @files;
    
    @files = sort @files;

    foreach $file (@files) {
		chomp $file;
		$file =~ s~[\r\n]~~g;

		$sel = "";

		if ($file eq $FORM{'template'} && $file ne '') {
		   	$sel = " selected";
		}

		if (substr($file, 0, 6) eq 'portal') {
		   	$yymain .= qq~
<option value="$file"$sel>$file</option>~;
		}
	}
	$yymain .= qq~
	</select>
	<input type="submit" name="submit" value="$portal{'template01'}">
	</font></td>
	</form>
  </tr>~;
  	if ($FORM{'submit'} eq "$txt{'10'}") {
		$FORM{'templatelines'} =~ tr/\r//d;
		$FORM{'templatelines'} =~ s~\A\n~~;
		$FORM{'templatelines'} =~ s~\n\Z~~;
		fopen(FILE, ">$FORM{'template'}");
		print FILE $FORM{'templatelines'};
		fclose(FILE);
   	}
  	if ($FORM{'submit'} ne '' && -e($FORM{'template'})) {
		fopen(FILE, "$FORM{'template'}");
		while( $line = <FILE> ) {
			$line =~ s~[\r\n]~~g;
			&FromHTML;
			$fulltemplate .= qq~$line\n~;
		}

  		$yymain .= qq~
  <tr>                                           
    <form action="$cgi;action=modportaltemp" method="POST">
    <td class="windowbg2" align="center"><font size=2>
    <input type="hidden" name="template" value="$FORM{'template'}">
    <textarea rows=30 cols=95 wrap=virtual name="templatelines" style="width:98%">$fulltemplate</textarea>
    <br><BR><input type="submit" name="submit" value="$txt{'10'}"></font></td>
    </form>
  </tr>~;
  	}
  $yymain .= qq~
</table>
~;
	$yytitle = "$portal{'01'}";
	&template;
	exit;
}

sub ModifyPortal {
	&is_admin;
	$yymain .= qq~
<table border=0 width="100%" cellspacing=1 class="bordercolor" cellpadding="4">
  <tr>
    <td class="titlebg">
    <img src="$imagesdir/xx.gif" alt="" border="0">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$portal{'02'}</b></font></td>
  </tr><tr> 
    <td class="windowbg">
    <font size=2>$portal{'portal13'}</font></td>
  </tr><tr>
    <td class="windowbg2" align="center">
    <font size="1">
      <table border=0 width="100%" cellspacing=0 class="bordercolor" cellpadding="0">
      <tr>
      <td>
      <table border=0 width=100% cellspacing=1 cellpadding="4">
	    <tr>
		  <td class="catbg" align="center" width="*"><b><font size=2>$portal{'portal01'}</font></b></td>
		  <td class="catbg" align="center" width="40%"><b><font size=2>$portal{'portal02'}</font></b></td>
		</tr>~;
    opendir(DIR,"$boardsdir");
    @files = readdir(DIR);
    closedir(DIR);

    chomp @files;

    @files = sort @files;

    foreach $file (@files) {
		chomp $file;
		$file =~ s~[\r\n]~~g;

		($name, $ending) = split(/\./, $file);

		if ($ending eq 'portal') {
		   	if ($name eq 'default') { $remove = ""; } else { $remove = qq~ - <a href="$scripturl?action=removeportalpage&pageid=$name">$portal{'portal04'}</a>~; }

		   	$yymain .= qq~
		<tr>
		  <td class="windowbg">
$name
          </td>
		  <td class="windowbg2">
<font size="1">
<a href="$scripturl?action=modportalpage&pageid=$name">$portal{'portal03'}</a>$remove
</font>
          </td>
		</tr>~;
		}
	}
	$yymain .= qq~
	  </table>
	  </td>
	  </tr>
	  </table>
	</font></td>
  </tr><tr>                     
    <form action="$scripturl?action=addportalpage" method="POST">
    <td class="windowbg2" align="center">
    <font size="2">
    $portal{'portal05'}: <input type="text" name="pageid">
    <input type="submit" value="$portal{'portal06'}">
    </font>   
    </td>
    </form>
  </tr>
</table>
~;
	$yytitle = "$portal{'02'}";
	&template;
	exit;
}

sub AddPortalPage {
	&is_admin;
	$id = $FORM{'pageid'};
	&fatal_error("$txt{'240'} $txt{'43'} $txt{'241'}") if($id !~ /\A[0-9A-Za-z#%+-\.@^_]+\Z/);

	# make sure no page already exists with that id

	if (-e("$boardsdir/$id.portal")) {
	    &fatal_error("$portal{'portal07'} $id $portal{'portal07a'}");
	} 

	fopen(FILE, ">$boardsdir/$id.portal");
	fclose(FILE);

	$yySetLocation = qq~$scripturl?action=modportal~;
	&redirectexit;
}

sub RemovePortalPage {
	&is_admin;
	$id = $INFO{'pageid'};
	&fatal_error("$txt{'240'} $txt{'43'} $txt{'241'}") if($id !~ /\A[0-9A-Za-z#%+-\.@^_]+\Z/);
	&fatal_error("$portal{'portal08'}") if($id eq 'default');

	if (!-e("$boardsdir/$id.portal")) {
	    &fatal_error("$portal{'portal07'} $id $portal{'portal07b'}");
	}

	unlink("$boardsdir/$id.portal");

	$yySetLocation = qq~$scripturl?action=modportal~;
	&redirectexit;
}

sub ModifyPortalPage {
	&is_admin;

	my $pageid = $INFO{'pageid'};
	
	if (!-e("$boardsdir/$pageid.portal")) {
	    &fatal_error("$portal{'portal07'} $pageid $portal{'portal07b'}");
	}

	$yymain .=qq~
<table border="0" align="center" cellspacing="1" cellpadding="4" class="bordercolor" width="90%">
  <tr>
    <td class="titlebg" colspan="2">
    <font class="text1" color="$color{'titletext'}" size="1"><b>$portal{'portal03'}</b></font></td>
  </tr><tr>    
    <td class="windowbg" colspan="2">
    <font size=2>$portal{'template02'}</font></td>
  </tr><tr>
    <form action="$scripturl?action=addpagecolumn&pageid=$pageid" method="POST">
    <td class="windowbg2" colspan="3">
    <table border="0" cellspacing="0" cellpadding="3">
      <tr>
        <td colspan="2">
        <table border="0" cellpadding="3" cellspacing="0">
          <tr>
            <td><font size="2">
            <b>$portal{'portal11'}: </b></font><select name="colid">~;

	fopen(FILE,"$boardsdir/$pageid.portal");
	@columns = <FILE>;
	fclose(FILE);
	
	chomp @columns;

	opendir(DIR, "$boardsdir");
	@files = readdir(DIR);
	closedir(DIR);
	
	chomp @files;

	@files = sort @files;

   	foreach $file (@files) {
		chomp $file;

		$file =~ s~[\r\n]~~g;

		($name, $ending) = split(/\./, $file);

	    my @foo = grep(/^$name$/, @columns);

		if ($ending eq 'boxes' && $#foo == -1) {
		   	$yymain .=qq~
<option value="$name">$name</option>~;
		}
	}

    $yymain .=qq~
           </select>&nbsp;<input type=submit value="$portal{'portal10'}">
         </td>
	   </tr>
	   </table>
	   </td>
      </tr>
    </table>
    </td> 
    </form>
  </tr><tr>
    <td class="titlebg" width="*"><font class="text1" color="$color{'titletext'}" size="1"><b>$portal{'portal11'}</b></font></td>
    <td class="titlebg" width="20%" align="right"><font class="text1" color="$color{'titletext'}" size="1"><b>$txt{'42'}</b></font></td>
  </tr>
~;
	
	for (my $i; $i < @columns; $i++) {
		$location = $columns[$i];

		chomp $location;
		$location =~ s~[\r\n]~~g;
		
		$updown = "";
		
		if ($i != 0) {
		   	$updown .= qq~
<a href="$scripturl?action=upportalcolumn&pageid=$pageid&column=$location"><img src="$imagesdir/button_up.gif" alt="" border="0"></a>&nbsp;~;
   		} else { $updown .= qq~&nbsp;&nbsp;&nbsp;&nbsp;~; }
		if ($i != $#columns) {
		   	$updown .= qq~
<a href="$scripturl?action=downportalcolumn&pageid=$pageid&column=$location"><img src="$imagesdir/button_down.gif" alt="" border="0"></a>&nbsp;~;
   		} else { $updown .= qq~&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;~; }

		$yymain .= qq~
  <tr>
    <td class="windowbg" height="25" border="0"><font size="2"><b>$location</b></font></td>
    <td class="windowbg2" height="25" border="0" align="right">$updown<font size="2"><a href="$scripturl?action=rempagecolumn&pageid=$INFO{'pageid'}&column=$location">$portal{'portal09'}</a></font></td>
  </tr>
~;
 	}
  	
  	$yymain .=qq~
</table>~;

  	$yytitle = $portal{'portal03'};

  	&template;
  	exit;
}

sub UpPortalColumn {
	&is_admin;
	
	my $pageid = $INFO{'pageid'};

	fopen(FILE,"$boardsdir/$pageid.portal");
	@columns = <FILE>;
	fclose(FILE);
	
	chomp @columns;
	
	for (my $i; $i < @columns; $i++) {
		$columns[$i] =~ s~[\r\n]~~g;

		$location = $columns[$i];

		chomp $location;

		if ($location eq $INFO{'column'} && $i != 0) {
		   	$columns[$i] = $columns[$i-1];
		   	$columns[$i-1] = $location;
		   	
		   	last;
   		}
 	}
 	
 	fopen(FILE,">$boardsdir/$pageid.portal");
 	print FILE join("\n", @columns);
 	fclose(FILE);

	$yySetLocation = qq~$scripturl?action=modportalpage&pageid=$pageid~;

  	&redirectexit;
}

sub DownPortalColumn {
	&is_admin;
	
	my $pageid = $INFO{'pageid'};

	fopen(FILE,"$boardsdir/$pageid.portal");
	@columns = <FILE>;
	fclose(FILE);
	
	chomp @columns;
	
	for (my $i; $i < @columns; $i++) {
		$columns[$i] =~ s~[\r\n]~~g;

		$location = $columns[$i];

		chomp $location;

		if ($location eq $INFO{'column'} && $i != $#columns) {
		   	$columns[$i] = $columns[$i+1];
		   	$columns[$i+1] = $location;
		   	
		   	last;
   		}
 	}
 	
 	fopen(FILE,">$boardsdir/$pageid.portal");
 	print FILE join("\n", @columns);
 	fclose(FILE);

	$yySetLocation = qq~$scripturl?action=modportalpage&pageid=$pageid~;

  	&redirectexit;
}

sub AddPageColumn {
	&is_admin;
	
	my $pageid = $INFO{'pageid'};
	
	if (!-e("$boardsdir/$pageid.portal")) {
	    &fatal_error("$portal{'portal07'} $pageid $portal{'portal07b'}");
	}

	fopen(FILE,"$boardsdir/$pageid.portal");
	@columns = <FILE>;
	fclose(FILE);
	
	chomp @columns;

	for (my $i; $i < @columns; $i++) {
		$columns[$i] =~ s~[\r\n]~~g;

		$location = $columns[$i];

		chomp $location;

		if ($location eq $FORM{'colid'}) {
		   	&fatal_error("$portal{'portal12'} $location $portal{'portal12a'}");
		}
 	}
 	
 	push(@columns, $FORM{'colid'});

 	fopen(FILE,">$boardsdir/$pageid.portal");
 	print FILE join("\n", @columns);
 	fclose(FILE);

	$yySetLocation = qq~$scripturl?action=modportalpage&pageid=$pageid~;

  	&redirectexit;
}

sub RemovePageColumn {
	&is_admin;
	
	my $pageid = $INFO{'pageid'};
	
	if (!-e("$boardsdir/$pageid.portal")) {
	    &fatal_error("$portal{'portal07'} $pageid $portal{'portal07b'}");
	}

	fopen(FILE,"$boardsdir/$pageid.portal");
	@columns = <FILE>;
	fclose(FILE);
	
	chomp @columns;
	
	my $foundcounter = 0;
	
	for (my $i; $i < @columns; $i++) {
		$columns[$i] =~ s~[\r\n]~~g;

		$location = $columns[$i];

		chomp $location;

		if ($location eq $INFO{'column'}) {
		   	$foundcounter = 1;
		   	
		   	splice(@columns, $i, 1);

		   	last;
		}
 	}
 	
 	if ($foundcounter == 0) {
	  	&fatal_error("$portal{'portal12'} $INFO{'column'} $portal{'portal12b'}");
	}

 	fopen(FILE,">$boardsdir/$pageid.portal");
 	print FILE join("\n", @columns);
 	fclose(FILE);

	$yySetLocation = qq~$scripturl?action=modportalpage&pageid=$pageid~;

  	&redirectexit;
}

sub ModifyPortalColumns {
	&is_admin;
	$yymain .= qq~
<table border=0 width="100%" cellspacing=1 class="bordercolor" cellpadding="4">
  <tr>
    <td class="titlebg">
    <img src="$imagesdir/xx.gif" alt="" border="0">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$portal{'03'}</b></font></td>
  </tr><tr>     
    <td class="windowbg">
    <font size=2>$portal{'column15'}</font></td>
  </tr><tr>
    <td class="windowbg2" align="center">
    <font size="1">
      <table border=0 width="100%" cellspacing=0 class="bordercolor" cellpadding="0">
      <tr>
      <td>
      <table border=0 width=100% cellspacing=1 cellpadding="4">
	    <tr>
		  <td class="catbg" align="center" width="*"><b><font size=2>$portal{'column01'}</font></b></td>
		  <td class="catbg" align="center" width="40%"><b><font size=2>$portal{'column02'}</font></b></td>
		</tr>~;
    opendir(DIR,"$boardsdir");
    @files = readdir(DIR);
    closedir(DIR);

    chomp @files;

    @files = sort @files;

    foreach $file (@files) {
		chomp $file;
		$file =~ s~[\r\n]~~g;

		($name, $ending) = split(/\./, $file);

		if ($ending eq 'boxes') {
		   	$yymain .= qq~
		<tr>
		  <td class="windowbg">
$name
          </td>
		  <td class="windowbg2">
<font size="1">
<a href="$scripturl?action=modportalcol&column=$name">$portal{'column03'}</a> - <a href="$scripturl?action=removeportalcol&column=$name">$portal{'column04'}</a>
</font>
          </td>
		</tr>~;
		}
	}
	$yymain .= qq~
	  </table>
	  </td>
	  </tr>
	  </table>
	</font></td>
  </tr><tr>                       
    <form action="$scripturl?action=addportalcol" method="POST">
    <td class="windowbg2" align="center">
    <font size="2">
    $portal{'column05'}: <input type="text" name="colid">
    <input type="submit" value="$portal{'column06'}">
    </font>    
    </td>
    </form>
  </tr>
</table>
~;
	$yytitle = "$portal{'03'}";
	&template;
	exit;
}

sub AddColumn {
	&is_admin;
	$id = $FORM{'colid'};
	&fatal_error("$txt{'240'} $txt{'43'} $txt{'241'}") if($id !~ /\A[0-9A-Za-z#%+-\.@^_]+\Z/);

	# make sure no column already exists with that id

	if (-e("$boardsdir/$id.boxes")) {
	    &fatal_error("$portal{'column07'} $id $portal{'column07a'}");
	}

	fopen(FILE, ">$boardsdir/$id.boxes");
	fclose(FILE);

	$yySetLocation = qq~$scripturl?action=modportalcols~;
	&redirectexit;
}

sub RemoveColumn {
	&is_admin;
	$id = $INFO{'column'};
	&fatal_error("$txt{'240'} $txt{'43'} $txt{'241'}") if($id !~ /\A[0-9A-Za-z#%+-\.@^_]+\Z/);

	if (!-e("$boardsdir/$id.boxes")) {
	    &fatal_error("$portal{'column07'} $id $portal{'column07b'}");
	}
	
	opendir(DIR,"$boardsdir");
	@files = readdir(DIR);
	closedir(DIR);
	
	chomp @files;

   	foreach $file (@files) {
		chomp $file;
		$file =~ s~[\r\n]~~g;

		($name, $ending) = split(/\./, $file);

		if ($ending eq 'portal') {
			fopen(FILE,"$boardsdir/$name.portal");
			@columns = <FILE>;
			fclose(FILE);

			chomp @columns;
			
			for (my $i; $i < @columns; $i++) {
				$columns[$i] =~ s~[\r\n]~~g;
		
				$location = $columns[$i];

				chomp $location;

				if ($location eq $id) {
				   	splice(@columns, $i, 1);
		
				   	last;
				}
		 	}
		
		 	fopen(FILE,">$boardsdir/$name.portal");
		 	print FILE join("\n", @columns);
		 	fclose(FILE);
		}
	}   

    unlink("$boardsdir/$id.boxes");

	$yySetLocation = qq~$scripturl?action=modportalcols~;
	&redirectexit;
}

sub ModifyColumn {
	&is_admin;
	
	my $column = $INFO{'column'};
	
	if (!-e("$boardsdir/$column.boxes")) {
	    &fatal_error("$portal{'column07'} $column $portal{'column07b'}");
	}

	$yymain .=qq~
<table border="0" align="center" cellspacing="1" cellpadding="4" class="bordercolor" width="90%">
  <tr>
    <td class="titlebg" colspan="2">
    <font class="text1" color="$color{'titletext'}" size="1"><b>$portal{'column03'}</b></font></td>
  </tr><tr>
    <td class="windowbg" colspan="2">
    <font size=2>$portal{'column16'}</font></td>
  </tr><tr>
    <td class="windowbg2" colspan="2">
    <table border="0" cellspacing="0" cellpadding="3">
      <tr>
        <td colspan="3">
        <table border="0" cellpadding="3" cellspacing="0">
          <tr>
            <form action="$scripturl?action=addcolumnbox&column=$column" method="POST">
            <td width="70%"><font size="2">
            <b>$portal{'column11'}: </b><select name="boxid"></font>~;

	fopen(FILE,"$boardsdir/$column.boxes");
	$width = <FILE>;
	chomp $width;
	@boxes = <FILE>;
	fclose(FILE);
	
	chomp @boxes;

	opendir(DIR, "$boardsdir");
	@files = readdir(DIR);
	closedir(DIR);
	
	chomp @files;

	@files = sort @files;

   	foreach $file (@files) {
		chomp $file;

		$file =~ s~[\r\n]~~g;

		($name, $ending) = split(/\./, $file);

	    my @foo = grep(/^$name$/, @boxes);

		if ($ending eq 'box' && $#foo == -1) {
		   	$yymain .=qq~
<option value="$name">$name</option>~;
		}
	}

    $yymain .=qq~
           </select>
		   &nbsp;<input type=submit value="$portal{'column10'}">
         </td>
         </form>
       </tr>
       <tr>
         <form action="$scripturl?action=modcolumnwidth&column=$column" method="POST">
         <td><font size="2">
           <b>$portal{'column13'}:</b> <input type="text" name="width" value="$width">
           &nbsp;<input type=submit value="$portal{'column14'}">
         </font>
         </td>
         </form>
	   </tr>
	   </table>
	   </td>
      </tr>
    </table>
    </td>
  </tr><tr>
    <td class="titlebg" width="*"><font class="text1" color="$color{'titletext'}" size="1"><b>$portal{'column11'}</b></font></td>
    <td class="titlebg" width="20%" align="right"><font class="text1" color="$color{'titletext'}" size="1"><b>$txt{'42'}</b></font></td>
  </tr>
~;
	
	for (my $i; $i < @boxes; $i++) {
		$box = $boxes[$i];

		chomp $box;
		$box =~ s~[\r\n]~~g;
		
		$updown = "";
		
		if ($i != 0) {
		   	$updown .= qq~
<a href="$scripturl?action=upcolumnbox&column=$column&box=$box"><img src="$imagesdir/button_up.gif" alt="" border="0"></a>&nbsp;~;
   		} else { $updown .= qq~&nbsp;&nbsp;&nbsp;&nbsp;~; }
		if ($i != $#boxes) {
		   	$updown .= qq~
<a href="$scripturl?action=downcolumnbox&column=$column&box=$box"><img src="$imagesdir/button_down.gif" alt="" border="0"></a>&nbsp;~;
   		} else { $updown .= qq~&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;~; }

		$yymain .= qq~
  <tr>
    <td class="windowbg" height="25" border="0"><font size="2"><b>$box</b></font></td>
    <td class="windowbg2" height="25" border="0" align="right">$updown<font size="2"><a href="$scripturl?action=remcolumnbox&column=$column&box=$box">$portal{'column09'}</a></font></td>
  </tr>
~;
 	}
  	
  	$yymain .=qq~
</table>~;

  	$yytitle = $portal{'column03'};

  	&template;
  	exit;
}

sub ModifyColumnWidth {
	&is_admin;
	
	my $column = $INFO{'column'};
	
	if (!-e("$boardsdir/$column.boxes")) {
	    &fatal_error("$portal{'column07'} $column $portal{'column07b'}");
	}

	fopen(FILE,"$boardsdir/$column.boxes");
	$width = <FILE>;
	chomp $width;
	@boxes = <FILE>;
	fclose(FILE);
	
	chomp @boxes;
	
	$width = $FORM{'width'};
 	
 	fopen(FILE,">$boardsdir/$column.boxes");
 	print FILE "$width\n";
 	print FILE join("\n", @boxes);
 	fclose(FILE);

	$yySetLocation = qq~$scripturl?action=modportalcol&column=$column~;

  	&redirectexit;
}

sub UpColumnBox {
	&is_admin;
	
	my $column = $INFO{'column'};

	fopen(FILE,"$boardsdir/$column.boxes");
	$width = <FILE>;
	chomp $width;
	@boxes = <FILE>;
	fclose(FILE);
	
	chomp @boxes;
	
	for (my $i; $i < @boxes; $i++) {
		$boxes[$i] =~ s~[\r\n]~~g;

		$box = $boxes[$i];

		chomp $box;

		if ($box eq $INFO{'box'} && $i != 0) {
		   	$boxes[$i] = $boxes[$i-1];
		   	$boxes[$i-1] = $box;
		   	
		   	last;
   		}
 	}
 	
 	fopen(FILE,">$boardsdir/$column.boxes");
 	print FILE "$width\n";
 	print FILE join("\n", @boxes);
 	fclose(FILE);

	$yySetLocation = qq~$scripturl?action=modportalcol&column=$column~;

  	&redirectexit;
}

sub DownColumnBox {
	&is_admin;
	
	my $column = $INFO{'column'};

	fopen(FILE,"$boardsdir/$column.boxes");
	$width = <FILE>;
	chomp $width;
	@boxes = <FILE>;
	fclose(FILE);
	
	chomp @boxes;
	
	for (my $i; $i < @boxes; $i++) {
		$boxes[$i] =~ s~[\r\n]~~g;

		$box = $boxes[$i];

		chomp $box;

		if ($box eq $INFO{'box'} && $i != $#boxes) {
		   	$boxes[$i] = $boxes[$i+1];
		   	$boxes[$i+1] = $box;
		   	
		   	last;
   		}
 	}
 	
 	fopen(FILE,">$boardsdir/$column.boxes");
 	print FILE "$width\n";
 	print FILE join("\n", @boxes);
 	fclose(FILE);

	$yySetLocation = qq~$scripturl?action=modportalcol&column=$column~;

  	&redirectexit;
}

sub AddColumnBox {
	&is_admin;
	
	my $column = $INFO{'column'};
	
	if (!-e("$boardsdir/$column.boxes")) {
	    &fatal_error("$portal{'column07'} $column $portal{'column07b'}");
	}

	fopen(FILE,"$boardsdir/$column.boxes");
	$width = <FILE>;
	chomp $width;
	@boxes = <FILE>;
	fclose(FILE);
	
	chomp @boxes;
	
	for (my $i; $i < @boxes; $i++) {
		$boxes[$i] =~ s~[\r\n]~~g;

		$box = $boxes[$i];

		chomp $location;

		if ($location eq $FORM{'boxid'}) {
		   	&fatal_error("$portal{'column12'} $box $portal{'column12a'}");
		}
 	}
 	
 	push(@boxes, $FORM{'boxid'});

 	fopen(FILE,">$boardsdir/$column.boxes");
 	print FILE "$width\n";
 	print FILE join("\n", @boxes);
 	fclose(FILE);

	$yySetLocation = qq~$scripturl?action=modportalcol&column=$column~;

  	&redirectexit;
}

sub RemoveColumnBox {
	&is_admin;
	
	my $column = $INFO{'column'};
	
	if (!-e("$boardsdir/$column.boxes")) {
	    &fatal_error("$portal{'column07'} $column $portal{'column07b'}");
	}

	fopen(FILE,"$boardsdir/$column.boxes");
	$width = <FILE>;
	chomp $width;
	@boxes = <FILE>;
	fclose(FILE);
	
	chomp @boxes;

	my $foundcounter = 0;
	
	for (my $i; $i < @boxes; $i++) {
		$boxes[$i] =~ s~[\r\n]~~g;

		$box = $boxes[$i];

		chomp $box;

		if ($box eq $INFO{'box'}) {
		   	$foundcounter = 1;
		   	
		   	splice(@boxes, $i, 1);

		   	last;
		}
 	}
 	
 	if ($foundcounter == 0) {
	  	&fatal_error("$portal{'column12'} $INFO{'box'} $portal{'column12b'}");
	}

 	fopen(FILE,">$boardsdir/$column.boxes");
 	print FILE "$width\n";
 	print FILE join("\n", @boxes);
 	fclose(FILE);

	$yySetLocation = qq~$scripturl?action=modportalcol&column=$column~;

  	&redirectexit;
}

sub ModifyPortalBoxes {
	&is_admin;
	$yymain .= qq~
<table border=0 width="100%" cellspacing=1 class="bordercolor" cellpadding="4">
  <tr>
    <td class="titlebg">
    <img src="$imagesdir/xx.gif" alt="" border="0">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$portal{'04'}</b></font></td>
  </tr><tr>
    <td class="windowbg">
    <font size=2>$portal{'box12'}</font></td>
  </tr><tr>
    <td class="windowbg2" align="center">
    <font size="1">
      <table border=0 width="100%" cellspacing=0 class="bordercolor" cellpadding="0">
      <tr>
      <td>
      <table border=0 width=100% cellspacing=1 cellpadding="4">
	    <tr>
		  <td class="catbg" align="center" width="*"><b><font size=2>$portal{'box01'}</font></b></td>
		  <td class="catbg" align="center" width="40%"><b><font size=2>$portal{'box02'}</font></b></td>
		</tr>~;
    opendir(DIR,"$boardsdir");
    @files = readdir(DIR);
    closedir(DIR);

    chomp @files;

    @files = sort @files;

    foreach $file (@files) {
		chomp $file;
		$file =~ s~[\r\n]~~g;

		($name, $ending) = split(/\./, $file);

		if ($ending eq 'box') {
		   	$yymain .= qq~
		<tr>
		  <td class="windowbg">
$name
          </td>
		  <td class="windowbg2">
<font size="1">
<a href="$scripturl?action=modportalbox&box=$name">$portal{'box03'}</a> - <a href="$scripturl?action=remportalbox&box=$name">$portal{'box04'}</a>
</font>
          </td>
		</tr>~;
		}
	}
	$yymain .= qq~
	  </table>
	  </td>
	  </tr>
	  </table>
	</font></td>
  </tr><tr>    
    <form action="$scripturl?action=addportalbox" method="POST">
    <td class="windowbg2" align="center">
    <font size="2">
    $portal{'box05'}: <input type="text" name="boxid">
    <input type="submit" value="$portal{'box06'}">
    </font>
    </td>
    </form>
  </tr>
</table>
~;
	$yytitle = "$portal{'04'}";
	&template;
	exit;
}

sub CreateBox {
	&is_admin;
	$id = $FORM{'boxid'};
	&fatal_error("$txt{'240'} $txt{'43'} $txt{'241'}") if($id !~ /\A[0-9A-Za-z#%+-\.@^_]+\Z/);

	# make sure no box already exists with that id

	if (-e("$boardsdir/$id.box")) {
	    &fatal_error("$portal{'box07'} $id $portal{'box07a'}");
	}

	fopen(FILE, ">$boardsdir/$id.box");
	fclose(FILE);

	$yySetLocation = qq~$scripturl?action=modportalboxes~;
	&redirectexit;
}

sub RemoveBox {
	&is_admin;
	$id = $INFO{'box'};
	&fatal_error("$txt{'240'} $txt{'43'} $txt{'241'}") if($id !~ /\A[0-9A-Za-z#%+-\.@^_]+\Z/);

	
	if (!-e("$boardsdir/$id.box")) {
	    &fatal_error("$portal{'box07'} $id $portal{'box07b'}");
	}

	opendir(DIR, "$boardsdir");
	@files = readdir(DIR);
	closedir(DIR);
	
	chomp @files;

    unlink("$boardsdir/$id.box");

   	foreach $file (@files) {
		chomp $file;
		$file =~ s~[\r\n]~~g;

		($name, $ending) = split(/\./, $file);

		if ($ending eq 'boxes') {
			fopen(FILE,"$boardsdir/$name.boxes");
			$width = <FILE>;
			chomp $width;
			@boxes = <FILE>;
			fclose(FILE);

			chomp @boxes;
			
			for (my $i; $i < @boxes; $i++) {
				$boxes[$i] =~ s~[\r\n]~~g;
		
				$box = $boxes[$i];

				chomp $box;

				if ($box eq $id) {
				   	splice(@boxes, $i, 1);
		
				   	last;
				}
		 	}
		
		 	fopen(FILE,">$boardsdir/$name.boxes");
		 	print FILE "$width\n";
		 	print FILE join("\n", @boxes);
		 	fclose(FILE);
		}
	}

	$yySetLocation = qq~$scripturl?action=modportalboxes~;
	&redirectexit;
}

sub ModifyBox {
	my $curbox = $INFO{'box'};
	my $boxcontent;
	
	if (!-e("$boardsdir/$curbox.box")) {
	    &fatal_error("$portal{'box07'} $curbox $portal{'box07b'}");
	}

	if ($FORM{'submit'} eq $txt{'17'}) {  
	    $FORM{'content'} =~ s~[\n]~~g;
		fopen(FILE, ">$boardsdir/$curbox.box", 1);
		$FORM{'visible'} = ($FORM{'visible'} eq 'on');
		print FILE "$FORM{'boxname'}\n";
	    print FILE "$FORM{'visible'}\n";
	    print FILE "$FORM{'content'}";
		fclose(FILE);
	}

	fopen(FILE,"$boardsdir/$curbox.box");
	$boxname = <FILE>;
	$visible = <FILE>;
	chomp $boxname;
	chomp $visible; 
	@boxcontents = <FILE>;
	fclose(FILE);

	chomp @boxcontents;

	$boxcontent .= join("\n", @boxcontents);
	
	$visiblechecked = ($visible == 1) ? ' checked' : '';
	
	$yymain .= qq~
<table border=0 width="100%" cellspacing=1 class="bordercolor" cellpadding="4">
  <tr>
    <td class="titlebg">
    <img src="$imagesdir/xx.gif" alt="" border="0">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$portal{'box03'}</b></font></td>
  </tr><tr>
    <td class="windowbg">
    <font size="2">$portal{'box11'}</font></td>
  </tr><tr>
    <td class="windowbg2" width="100%" valign="top" colspan="3">
    <table border="0" cellspacing="0" cellpadding="3">                
    <form action="$scripturl?action=modportalbox&box=$curbox" method="POST">
      <tr>
        <td width="80%">
		<font size="2">
        <b>$portal{'box08'}:</b> <input type="text" name="boxname" value="$boxname" size="30">
		<br><br><input type="checkbox" name="visible"$visiblechecked> $portal{'box09'}?
		<br><br><b>$portal{'box10'}:<br></b><textarea name="content" cols="80" rows="4">$boxcontent</textarea>
		</font>
		</td>
        <td valign="middle" align="center" width="20%"><input type="submit" name="submit" value="$txt{'17'}"></tx>
      </tr>   
    </form>
    </table>
  </td>    
  </tr>
  </table>
~;

  	$yytitle = "$portal{'box03'}";

  	&template;
  	exit;
}

1;
