###############################################################################
# Portal.pl                                                                   #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.3                                        #
# Released:       December 2001; Updated April 6, 2003                        #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2003 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Portal.pl by Daniel Alm.                                                    #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
###############################################################################

use LWP::UserAgent;

$portalplver = "1.00";

sub DisplayPortal {
	my $i;
	
	my( @memset, @boards, $curboard, %data, %cat, $numfound, $oldestfound, $curcat, %catname, %cataccess, %catboards, $openmemgr, @membergroups, %openmemgr, $curboard, @threads, @boardinfo, $i, $c, @messages, $tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mns, $mtime, $counter, $board, $notify );
	
	if ($INFO{'template'} == 2) {
	   	$yymain .= qq~
      <table>~;
 	}
	
 	$portal = $INFO{'portal'} || 'default';
	
	if ($INFO{'box'} eq '') {
		if ($INFO{'column'} eq '') {
			fopen(FILE,"$boardsdir/$portal.portal");
			@columns = <FILE>;
			fclose(FILE);
		} else {
			@columns = ($INFO{'column'});
		}
		
		foreach $location (@columns) {
			chomp $location;
	
	        fopen(FILE,"$boardsdir/$location.boxes");
	        $width = <FILE>;
	        chomp $width;
	  		@boxes=<FILE>;
	  		fclose(FILE);
	
			if ("@boxes" ne '' && "@boxes" ne '\n') {
			   	$anyvisible = 0;
	
				foreach $curbox (@boxes) {
				    chomp $curbox;
				    
				    if ($curbox eq '') { next; }
	
					fopen(FILE,"$boardsdir/$curbox.box");
				    $boxname=<FILE>;
				    $visible=<FILE>;
				    chomp $visible;
				    @boxcontents=<FILE>;
				    fclose(FILE);
				    
				    if ($visible == 1) { $anyvisible = 1; last; }
				}
	
				if ($anyvisible == 1) {
			   	   $yymain .= qq~
	    <td class="portalrow" width="$width">~;
					foreach $curbox (@boxes) {
					    chomp $curbox;
					    
					    if ($curbox eq '') { next; }
		
						&PrintBox($curbox);
					}
					$yymain .= qq~
	    </td>~;
	 		   	}
			}
	 	}
	} else {
	    $yymain .= qq~
	    <td class="portalrow" width="100%">~;
	  	&PrintBox($INFO{'box'});
	  	$yymain .= qq~
	    </td>~;
	}
	
	if ($INFO{'template'} == 2) {
	   	$yymain .= qq~
      </table>~;
 	}      
	
	$yytime = &timeformat($date, 1);
	$yyuname = $username eq 'Guest' ? qq~$txt{'248'} $txt{'28'}. $txt{'249'} <a href="$cgi;action=login">$txt{'34'}</a> $txt{'377'} <a href="$cgi;action=register">$txt{'97'}</a>.~ : qq~$txt{'247'} $realname, ~ ;
	
	$guests = 0;
	$users = '';
	$numusers = 0;
	fopen(FILE, "$vardir/log.txt");
	@entries = <FILE>;
	fclose(FILE);
	foreach $curentry (@entries) {
		chomp $curentry;
		($name, $value) = split(/\|/, $curentry);
		if($name) {
			if(!$yyUDLoaded{$musername}) { &LoadUser($name); }
			if(exists $userprofile{$name}) {
				$numusers++;
				$users .= qq~ <a href="$scripturl?action=viewprofile;username=$useraccount{$name}">$userprofile{$name}->[1]</a><font size="1">,</font> \n~;
			}
			else { $guests++; }
		}
	}
	$users =~ s~<font size="1">,</font> \n\Z~~;

	$uonline = qq~$guests $txt{'141'}, $numusers $txt{'142'}<BR>$users~;
	
	if ($username eq 'Guest') {
		$login .= qq~
	<form action="$cgi;action=portallogin2" method="POST" name="form">
	<center>
	<input type=text name="username" size=15 tabindex="1"><br>
	<input type=password name="passwrd" size=15 tabindex="2"><br><br>
	<input type=hidden name="cookielength" size="7" maxlength="4" value="$Cookie_Length">
	<input type=hidden name="cookieneverexp" checked>
	<input type=submit value="$txt{'34'}" tabindex="3" accesskey="l">
	</center>
	</form>
    <script language="JavaScript"> <!--
		document.form.username.focus();
	//--> </script>
~;
	    $im="";
	} else {
	    $login="";
	    $im="$yyuname $yyim";
	}

  	$yytitle=$portal{'10'};

	if ($INFO{'template'} == 1) { &portaltemplate("portalwidetemplate.html"); }
	elsif ($INFO{'template'} == 2) { &portaltemplate(""); }
	elsif ($INFO{'template'} eq '') { &portaltemplate("portaltemplate.html"); }
	else { &portaltemplate($INFO{'template'}); }
}

sub GetBoardThreads {
	my $currentboard = $_[0];
	my $boardentries = $_[1];
	my $mode = $_[2];
	my $numchars = $_[3];

	my (@threads, @yyBoardInfo);
	
	my ($newsboard, $newslist);
	
	my $i = 0;

	unless( &BoardAccessGet($currentboard) ) { return $txt{'1'}; }

	fopen(FILE, "$boardsdir/$currentboard.dat") || &fatal_error("400 $txt{'106'}: $txt{'23'} $currentboard.dat");
	my @yyBoardInfo =<FILE>;
	fclose(FILE);

	chomp @yyBoardInfo;

	# Create Hash %moderators with all Moderators of the current board
	foreach(split(/\|/,$yyBoardInfo[2])) {
		fopen(MODERATOR, "$memberdir/$_.dat");
		@modprop = <MODERATOR>;
		fclose(MODERATOR);
		$modprop[1] =~ s/[\n\r]//g;
		$moderators{$_} = $modprop[1];
	}

	fopen(FILE,"$boardsdir/$currentboard.txt");
	@threads=<FILE>;
	fclose(FILE);

	if ("@threads" ne '') {
		foreach $thread (@threads) {
			$i++;
			
			if ($i > $boardentries && $boardentries != -1) { last; }

			($tnum, $title, $mnickname, $memail, $postdate, $replies, $musername, $icon, $status) = split( /\|/, $thread);

			fopen(FILE,"$datadir/$tnum.txt");
			$posting=<FILE>;
			fclose(FILE);

			($title, $mnickname, $memail, $postdate, $musername, $icon, $attach, $ip, $mtext,) = split( /\|/, $posting);

			fopen(FILE,"$datadir/$tnum.data");
			$postingdata=<FILE>;
			fclose(FILE);

			($views, $mauthor) = split( /\|/, $postingdata);

			if (-e("$memberdir/$musername.dat")) {
			    fopen(FILE,"$memberdir/$musername.dat");
			    @msettings=<FILE>;
			    fclose(FILE);

			    chomp @memsettings;

			    $mnickname=$msettings[1];
			}

			chomp $mnickname;

			# Censor the subject and message.
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$postmessage =~ s~\Q$tmpa\E~$tmpb~gi;
				$msub =~ s~\Q$tmpa\E~$tmpb~gi;
			}

			# Run UBBC interpreter on the message.
			$message = $mtext; # put the message back into the proper variable to do ubbc on it
			&wrap;
			if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
			&wrap2;
			if (length($message) > $numchars && $numchars ne '') {
			   	$numbrackets = 0;
			   	$bracket = 0;
			   	$endhere = 0;   
			   	$endnow = 0;
			   	for (my $ix = 0; $ix <= length($message) && $endnow == 0; $ix++) {
					$curchar = substr($message,$ix,1);
					if ($curchar eq '<' && substr($message,$ix+1,1) ne '/') {
					   	$bracket = 1;
					   	$numbrackets++;
					} elsif ($curchar eq '<' && substr($message,$ix+1,1) eq '/') {
					   	$bracket = 2;
					} elsif ($curchar eq '>') {
						$numbrackets -= ($bracket == 2) ? 1 : 0;
					    $bracket = 0;
					}
					$endhere = $ix + 1;
				    if ($numbrackets == 0 && $ix >= $numchars) {
					   	$endnow = 1;
					}
				}
				$message = substr($message,0,$endhere);
   			}
			$newslist .=qq~
<a href="$scripturl?board=$currentboard;action=display;num=$tnum">$title</a><br>~;
			$newsboard .=qq~
<table width="100%" class="news" cellSpacing="0" align="center" border="0">
<tr class="head">
<td class="title">
<img src="$imagesdir/$icon.gif" alt=""><a href="$scripturl?board=$currentboard;action=display;num=$tnum">$title</a>
</td>
</tr>
<tr>
<td class="author">
$portal{'20'} <a href="$scripturl?action=viewprofile;username=$musername">$mnickname</a> $portal{'21'} $postdate
</td>
</tr>
<tr class="newstext">
<td>
$message
</td>
</tr>
<tr class="foot">
<td>
<table width="100%">
<td class="views">
$portal{'22'}: <b>$views</b>
</td>
<td class="comments">
<a href="$scripturl?board=$currentboard;action=display;num=$tnum#1">$portal{'23'} ($replies)</a>
</td>
</table>
</td>
</tr>
</table>
<br>~;
		}
  	}

  	if ($mode == 0) { return $newslist; } else { return $newsboard; }
}

sub GetRecent {
	my $recententries = $_[0];
	my $mode = $_[1];
	
	my ($recentlist, $recent);
	
	my( @memset, @categories, %data, %cat, $numfound, $oldestfound, $curcat, %catname, %cataccess, %catboards, $openmemgr, @membergroups, %openmemgr, $curboard, @threads, @boardinfo, $i, $c, @messages, $tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mns, $mtime, $counter, $board, $notify );

	@categories = ();
	fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);

	$oldestfound = stringtotime("01/10/37 $txt{'107'} 00:00:00");

	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
		$catname{$curcat} = <FILE>;
		chomp $catname{$curcat};
		$cataccess{$curcat} = <FILE>;
		chomp $cataccess{$curcat};
		@{$catboards{$curcat}} = <FILE>;
		fclose(FILE);
		$openmemgr{$curcat} = 0;
		@membergroups = split( /,/, $cataccess{$curcat} );
		foreach $tmpa (@membergroups) {
			if( $tmpa eq $settings[7]) { $openmemgr{$curcat} = 1; last; }
		}
		if( ! $cataccess{$curcat} || $settings[7] eq 'Administrator' || $settings[7] eq "Global Moderator") {
			$openmemgr{$curcat} = 1;
		}
		unless( $openmemgr{$curcat} ) { next; }
		foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			fopen(FILE, "$boardsdir/$curboard.txt");
			@threads = <FILE>;
			fclose(FILE);

			fopen(FILE, "$boardsdir/$curboard.dat");
			@boardinfo = <FILE>;
			fclose(FILE);
			foreach (@boardinfo) {
				chomp;
			}
			@{$boardinfo{$curboard}} = @boardinfo;
			$cat{$curboard} = $curcat;

			for ($i = 0; $i < @threads; $i++) {
				chomp $threads[$i];
				($tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate) = split( /\|/, $threads[$i] );
				fopen(FILE, "$datadir/$tnum.txt") || next;
				$message = <FILE>;
				fclose(FILE);

				chomp $message;
				if( $message ) {
					($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns) = split(/\|/,$message);
					$mtime = stringtotime($mdate);
					if( $numfound >= $recententries && $mtime <= $oldestfound ) {
						next;
					}
					else {
						$data{$mtime} = [$curboard, $tnum, $treplies, $tusername, $tname, $msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns, $tstate];
						if( $mtime < $oldestfound ) { $oldestfound = $mtime; }
						++$numfound;
					}
				}
			}
		}
	}
	
	@messages = sort {$b <=> $a } keys %data;

	if("@messages" ne '') {
		if ($#messages > $recententries - 1) { $#messages = $recententries - 1; }
		$counter = 1;
		# Load Censor List
		&LoadCensorList;
		
		$recent .= qq~
<table cellpadding="4" cellspacing="1" border="0" width="100%" class="recent">
  <tr>
    <td width="4%">&nbsp;</td>
    <td width="44%"><b>$txt{'70'}</b></td>
    <td width="4%" align="center"><b>$txt{'110'}</b></td>
    <td width="4%" align="center"><b>$txt{'301'}</b></td>
    <td width="30%"><b>$txt{'111'}</b></td>
  </tr>~;
	}
	else {
		$recent .= qq~$portal{'30'}~;
		$recentlist .= qq~$portal{'30'}~;
	}
          
	foreach (@messages) {
		($board, $tnum, $c, $tusername, $tname, $msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns, $tstate) = @{ $data{$_} };
		$displayname = $mname;
		if( $tusername ne 'Guest' ) {
			&LoadUser($tusername);
			$tname = exists $userprofile{$tusername} ? $userprofile{$tusername}->[1] : $tname;
			$tname ||= $txt{'470'};
			$tname = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$tusername}" alt="$txt{'27'}: $musername">$tname</a>~;
		}
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$message =~ s~\Q$tmpa\E~$tmpb~gi;
			$msub =~ s~\Q$tmpa\E~$tmpb~gi;
		}
		
		$threadclass = 'thread';

		$showicon = $micon;

		# Load the current nickname of the account name of the thread starter.
		$micon = qq~<img src="$imagesdir/$micon.gif" alt="" border="0" align="middle">~;

		if( $musername ne 'Guest' && -e "$memberdir/$musername.dat" ) {
			&LoadUser($musername);
			$mname = $userprofile{$musername}->[1] || $mname || $txt{'470'};
			$mname = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$musername}">$mname</a>~;
		}
		else {
			$mname ||= $txt{'470'};
		}

		# Censor the subject of the thread.
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$msub =~ s~\Q$tmpa\E~$tmpb~gi;
		}

		# Decide how many pages the thread should have.
		$threadlength = $mreplies + 1;
		$pages = '';
		if( $threadlength > $maxmessagedisplay ) {
			$tmpa = 1;
			for( $tmpb = 0; $tmpb < $threadlength; $tmpb += $maxmessagedisplay ) {
				$pages .= qq~<a href="$cgi;action=display;num=$tnum;start=$tmpb#$tmpb">$tmpa</a>\n~;
				++$tmpa;
			}
			$pages =~ s/\n\Z//;
			$pages = qq~<BR><font size="1">&#171; $txt{'139'} $pages &#187;</font>~;
		}

		if(fopen(FILE, "$datadir/$tnum.data")) {
			$tmpa = <FILE>;
			@other_stuff = <FILE>;
			fclose(FILE);
			chomp $tmpa;
		}
		elsif( -e "$datadir/$tnum.data" ) {
			&fatal_error("301 $txt{'106'}: $txt{'23'} $tnum.data");
		}
		else {
			$tmpa = '0';
		}


		($views, $lastposter) = split(/\|/, $tmpa);
		if( $lastposter =~ m~\AGuest-(.*)~ ) {
			$lastposter = $1;
		}
		else {
			unless( $lastposter eq $txt{'470'} ) {
				$lastposterid = $lastposter;
				&LoadUser($lastposterid);
				if($userprofile{$lastposter}->[1]) { $lastposter = qq~<a href="$scripturl?action=viewprofile;username=$lastposterid">$userprofile{$lastposter}->[1]</a>~; }
			}
			&LoadUser($lastposter);
		}
		$lastpostername = $lastposter || $txt{'470'};
		$views = $views ? $views - 1 : 0;

		# Print the thread info.
		$mydate = &timeformat($mdate);
		$recent .= qq~
  <tr>
    <td valign="middle" align="center" width="4%">$micon</td>
    <td valign="middle" width="44%"><a href="$scripturl?board=$board;action=display;num=$tnum">$msub</a> $pages</td>
    <td valign="middle" width="4%" align="center">$treplies</td>
    <td valign="middle" width="4%" align="center">$views</td>
    <td valign="middle" width="30%">$mydate $txt{'525'} $lastpostername</td>
  </tr>
~;
  	   $recentlist .= qq~<a href="$scripturl?board=$board;action=display;num=$tnum">$msub</a><br>~;

		++$counter;
	}

	if ("@messages" ne '') { 
	   	$recent .= qq~
</table>
~;
  	}

  	if ($mode == 0) { return $recentlist; } else { return $recent; }
}

sub PrintBox {
	my $curbox = $_[0];
	
	fopen(FILE,"$boardsdir/$curbox.box");
    $boxname=<FILE>;
    $visible=<FILE>;
	chomp $visible;
    @boxcontents=<FILE>;
    fclose(FILE);
    
    $boxcontent=join("\n",@boxcontents);

    chomp $boxname;
    
    chomp $boxcontent;
    
    if ($visible == 1 || $INFO{'box'} ne '') {
	    $yymain .= qq~
	      <table class="portalitem" cellpadding="0" cellspacing="0">~;
	    if ($INFO{'title'} ne '0') {
		   	$yymain .= qq~
	        <tr>
	          <td class="heading">$boxname</td>
	        </tr>~;
	    }
	    $yymain .= qq~
	        <tr>
	          <td>$boxcontent</td>
	        </tr>
	      </table>
	      <br>~;
	}
}

sub portaltemplate {
	my $template = $_[0];

	if($yySetCookies1 || $yySetCookies2 || scalar @otherCookies) { print header(-status=>"200 OK", -cookie=>[$yySetCookies1, $yySetCookies2, @otherCookies], -charset=>$yycharset); }
	else { print header(-status=>"200 OK", -charset=>$yycharset); }

	$yyposition = $yytitle; $yytitle = "$mbname - $yytitle";

	$yyimages = $imagesdir;

	if ($template ne '') {
		fopen(TEMPLATE,"$template") || die("$txt{'23'}: $template");
		@yytemplate = <TEMPLATE>;
		fclose(TEMPLATE);
	} else {
	    @yytemplate = "<yabb main>";
	}
	
	if($enable_news) {
		fopen(FILE, "$vardir/news.txt");
		@newsmessages = <FILE>;
		fclose(FILE);
		if ("@newsmessages" ne '' && "@newsmessages" ne '\n') {
			$news = qq~<marquee>~;
			$news .= join(' +++ ', @newsmessages);
			$news .= qq~</marquee>~;
		} else {
		  	$news = $portal{'70'};
  		}
	} else {
	    $news = $portal{'70'};
	}
	
	$yycopyright = qq~
YaBB Portal Version $portalplver - Copyright  2004 by <a href="mailto:Muskelkater2@gmx.de">MrMage</a><br>
Thanks for some bug fixes to <a href="http://pagesfromsages.com/" target="_blank">pagesfromsages</a><br><br>
$yycopyright~;

	for(my $i = 0; $i < @yytemplate; $i++) {
		$curline = $yytemplate[$i];
		
		if(!$yycopyin && $curline =~ m~<yabb copyright>~) { $yycopyin = 1; }

		$curline =~ s~<yabb\s+(\w+)>~${"yy$1"}~g;
		$curline =~ s~<\$+(\w+)>~${"$1"}~g;

		while ($curline =~ /<RECENTLIST [0-9]+>/g) {
		   	$recentnum = substr($curline,index($curline,"<RECENTLIST ")+12,index($curline,">",index($curline,"<RECENTLIST ")+12)-index($curline,"<RECENTLIST ")-12);

		   	chomp $recentnum;

		   	$currecentlist=&GetRecent($recentnum,0);

		   	$curline =~ s~<RECENTLIST $recentnum>~$currecentlist~g;
		}
		
		while ($curline =~ /<RECENT [0-9]+>/g) {
		   	$recentnum = substr($curline,index($curline,"<RECENT ")+8,index($curline,">",index($curline,"<RECENT ")+8)-index($curline,"<RECENT ")-8);

		   	chomp $recentnum;

		   	$currecent=&GetRecent($recentnum,1);

		   	$curline =~ s~<RECENT $recentnum>~$currecent~g;
		} 
		
		while ($curline =~ /<BOARD [0-9]+ [0-9A-Za-z#%+-\.@^_]+ [0-9]+>/g) {
		   	$boardparams = substr($curline,index($curline,"<BOARD ")+7,index($curline,">",index($curline,"<BOARD ")+7)-index($curline,"<BOARD ")-7);
			($entrynum, $boardname, $numchars) = split(/ /, $boardparams);
		   	chomp $entrynum;
		   	chomp $boardname;
		   	chomp $numchars;

		   	$curboardtxt=&GetBoardThreads($boardname,$entrynum,1,$numchars);

		   	$curline =~ s~<BOARD $entrynum $boardname $numchars>~$curboardtxt~g;
		}
		
		while ($curline =~ /<BOARD [0-9]+ [0-9A-Za-z#%+-\.@^_]+>/g) {
		   	$boardparams = substr($curline,index($curline,"<BOARD ")+7,index($curline,">",index($curline,"<BOARD ")+7)-index($curline,"<BOARD ")-7);
			($entrynum, $boardname) = split(/ /, $boardparams);
		   	chomp $entrynum;
		   	chomp $boardname;

		   	$curboardtxt=&GetBoardThreads($boardname,$entrynum,1);

		   	$curline =~ s~<BOARD $entrynum $boardname>~$curboardtxt~g;
		}

		while ($curline =~ /<BOARDLIST [0-9]+ [0-9A-Za-z#%+-\.@^_]+>/g) {
		   	$boardparams = substr($curline,index($curline,"<BOARDLIST ")+11,index($curline,">",index($curline,"<BOARDLIST ")+11)-index($curline,"<BOARDLIST ")-11);
			($entrynum, $boardname) = split(/ /, $boardparams);
		   	chomp $entrynum;
		   	chomp $boardname;

		   	$curboardtxt=&GetBoardThreads($boardname,$entrynum,0);

		   	$curline =~ s~<BOARDLIST $entrynum $boardname>~$curboardtxt~g;
		}
		
		while ($curline =~ /<POLL [0-9]+ [0-9A-Za-z#%+-\.@^_]+>/g) {
		   	$pollparams = substr($curline,index($curline,"<POLL ")+6,index($curline,">",index($curline,"<POLL ")+6)-index($curline,"<POLL ")-6);
			($pollnum, $boardname) = split(/ /, $pollparams);
		   	chomp $pollnum;
		   	chomp $boardname;

		   	$curpolltxt=&GetPoll($pollnum,$boardname);

		   	$curline =~ s~<POLL $pollnum $boardname>~$curpolltxt~g;
		}

		while ($curline =~ /<INCLUDE .+>/g) {
		   	$urltoinclude = substr($curline,index($curline,"<INCLUDE ")+9,index($curline,">",index($curline,"<INCLUDE ")+9)-index($curline,"<INCLUDE ")-9);

		   	chomp $urltoinclude;

		   	$curinclude = &IncludeExternalPage($urltoinclude);
		   	
		   	$urltoinclude =~ s~\?~\E\\\?~g;

		   	$curline =~ s~<INCLUDE $urltoinclude>~$curinclude~g;
		}
		
		$curline =~ s~<yabb\s+(\w+)>~${"yy$1"}~g;
		$curline =~ s~<\$+(\w+)>~${"$1"}~g;

		print $curline;
	}
	
	if($yycopyin == 0) {
		print q~<center><font size=5><B>Sorry, the copyright tag <yabb copyright> must be in the template.<BR>Please notify this forum's administrator that this site is using an ILLEGAL copy of YaBB!</B></font></center>~;
	}
}

sub IncludeExternalPage {
	my $page = $_[0];

	my $content;

	my $agent = LWP::UserAgent->new(agent=>"YaBB Portal");
	my $response=$agent->get("$page");

	if ($response->is_success)
	{
	   	$content = $response->content;
	}

	return $content;
}

sub GetPoll {
	my $viewnum = $_[0];
	my $scboard = $_[1];
	
	my $pollthread = 0;
	
	my $i = 0;
	my $poll = "";

	# Look for a valid poll file.
	if (-e "$datadir/$viewnum.poll") {
		$pollthread = 1;

		if (!($settings[7] ne "Administrator" && $access ne "granted")) {
		   unless( &BoardAccessGet($scboard) ) { $pollthread = 0; }
		}
		if ($pollthread == 1) {
			$poll .= qq~<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>~;
			$pollnum = $viewnum;
			$brdpid = $scboard;
		
			&LoadCensorList;	# Load Censor List
		
			fopen (FILE, "$datadir/$pollnum.poll");
			$poll_question = <FILE>;
			@poll_data = <FILE>;
			fclose (FILE);
			chomp $poll_question;
			($poll_question, $poll_locked, $poll_uname, $poll_name, $poll_email, $poll_date, $guest_vote, $hide_results, $multi_vote, $poll_mod, $poll_modname, $poll_comment) = split(/\|/, $poll_question);
		
			$has_voted = 0;
			if (!$guest_vote && $username eq "Guest") { $has_voted = 4; }
			else {
				fopen(FILE, "$datadir/$pollnum.polled");
				@polled = <FILE>;
				fclose(FILE);
				foreach $tmpLine (@polled){
					chomp $tmpline;
					($voters_ip, $voters_name, $voters_vote, $vote_date) = split(/\|/, $tmpLine);
					   if ($username eq "Guest" && $voters_name eq "Guest" && lc $voters_ip eq lc $user_ip) { $has_voted = 1; last; }
					elsif ($username eq "Guest" && $voters_name ne "Guest" && lc $voters_ip eq lc $user_ip) { $has_voted = 2; last; }
					elsif ($username ne "Guest" && lc $username eq lc $voters_name) { $has_voted = 3; last; }
				}
			}

			my @options;
			my @votes;
			my $totalvotes = 0;
			my $maxvote = 0;
			for(my $i = 0; $i < @poll_data; $i++) {
				chomp $poll_data[$i];
				($votes[$i], $options[$i]) = split(/\|/, $poll_data[$i]);
				$totalvotes += int($votes[$i]); 
				if (int($votes[$i]) >= $maxvote) { $maxvote = int($votes[$i]); }
			}
		
			if ($poll_locked) {
				$endedtext = qq~<tr>
		                  <td colspan="2" align="center"><font size="2"><b>$polltxt{'22'}</b></font><br><br></td>
		                </tr>~;
				$has_voted = 5;
			}
		
			# Censor the question.
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$poll_question =~ s~\Q$tmpa\E~$tmpb~gi;
				$poll_comment =~ s~\Q$tmpa\E~$tmpb~gi;
			}
			if($ubbcpolls) { 
				if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; }
				$message = $poll_question;
				&DoUBBC;
				$poll_question = $message;
			}
		
			$deletevote = "";
			if ($has_voted) {
				$footer = qq~$polltxt{'17'}: $totalvotes~;
				$width = qq~~;
			} else {
				$footer = qq~<input type="submit" value="$polltxt{'18'}">~;
				$width = qq~ width="80%"~;
			}
			if ($username eq "Guest") { $deletevote = ""; }
			if ($poll_locked) { $deletevote = ""; }
		
			$poll .= qq~
		<table cellpadding="0" cellspacing="0" border="0" width="100%" align="center">
		  <tr>
		    <td>
		      <table cellpadding="3" cellspacing="1" border="0" width="100%">
		        <tr>
		          <td align="left" width="100%">
		            <table cellpadding="0" cellspacing="0" border="0" width="100%">
		              <tr>
		                <td valign="middle" align="center" width="30%">$boardpoll</td>
		                <td valign="middle" align="right" width="35%"><font size="1" color="$color{'titletext'}">$lockpoll$modifypoll$deletepoll</font></td>
		              </tr>
		            </table>
		          </td>
		        </tr>
		        <tr>
		          <td valign="top" align="center" class="windowbg2">
		            <form name="poll" method="post" action="$cgi&action=portalvote&num=$pollnum" style="display:inline">
		              <table border="0" width="100%" cellspacing="0" cellpadding="0">
		                <tr>
		                  <td colspan="2"><font size="2"><b>$polltxt{'16'}:</b> $poll_question</font><br><br></td>
		                </tr>$endedtext<tr>
		                  <td colspan="2" align="center">~;

			if ($has_voted && $hide_results && !$poll_locked) {

				# Display Poll Hidden Message
				$poll .= qq~<font size="2">$polltxt{'47'}</font><br><font size="1">($polltxt{'48'})</font><br>~;

			} else {
		
				$poll .= qq~
		                     <table$width border="0" cellspacing="2" cellpadding="0">~;
		
				for($i = 0; $i < @options; $i++) {

					unless ($options[$i]) {next;};
		
					# Censor the options.
					foreach (@censored) {
						($tmpa,$tmpb) = @{$_};
						$options[$i] =~ s~\Q$tmpa\E~$tmpb~gi;
					}
					$options[$i] =~ s~[\n\r]~~g;
		
					if($ubbcpolls) {
						if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; }
						$message = $options[$i];
						&DoUBBC;
						$options[$i] = $message;
					}
		
					if ($has_voted) {
		
						# Display Poll Results
		
						$pollpercent = 0;
						$pollbar = 0;
						if ($totalvotes ne 0 && $maxvote ne 0) {
							$pollpercent = int(1000 * $votes[$i] / $totalvotes);
							$pollpercent = $pollpercent / 10;
							$pollbar = int( 150 * $votes[$i] / $maxvote);
						}
		
						$poll .= qq~
		                      <tr>
		                        <td valign="middle" width=60%><font size="2"><b>$options[$i]&nbsp;&nbsp;</b></font></td>
		                        <td valign="middle" width=150><font size="2">&nbsp; $votes[$i] ($pollpercent%)</font></td>
		                      </tr>~;
		
					} else {
		
						# Display Poll Options
						if ($multi_vote) { $input = qq~<input type="checkbox" name="option$i" value="$i">~; } else { $input = qq~<input type="radio" name="option" value="$i">~; }

						$poll .= qq~
		                      <tr>
		                        <td valign="middle" width="25">$input</td>
		                        <td valign="middle"><font size="2"><b>$options[$i]</b></font></td>
		                      </tr>~;
		
					}
				} 
				$poll .= qq~
		                    </table>~;
			} 
		
			$poll .= qq~
		                  </td>
		                </tr><tr>
		                  <td colspan="2" align="center"><br><font size="2"><b>$footer</b></font></td>
		                </tr><tr>~;
				if ($poll_comment ne "") {
					$message = $poll_comment;
					if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
					$poll_comment = $message;
					$poll .= qq~
		                  <td colspan="2"><br><font size="2">$poll_comment</font></td>
		                </tr><tr>~;}
				$poll .= qq~
		                </tr>
		              </table>
		            </form>
		          </td>
		        </tr>
		      </table>
		    </td>
		  </tr>
		</table>~;
			}
	}

	if ($pollthread == 0) { $poll = $portal{'50'}; }
	
	return $poll;
}

sub DoPortalVote {
	$pollnum = $INFO{'num'};
	unless (-e "$datadir/$pollnum.poll") {&fatal_error("$polltxt{'14'}: $pollnum");}
	
	$novote = 0;
	$vote = "";
	fopen (FILE, "$datadir/$pollnum.poll");
	$poll_question = <FILE>;
	@poll_data = <FILE>;
	fclose (FILE);
	chomp $poll_question;
	($dummy, $poll_locked, $dummy, $dummy, $dummy, $dummy, $guest_vote, $dummy, $multi_vote, $dummy, $dummy) = split(/\|/, $poll_question);
	for(my $i = 0; $i < @poll_data; $i++) {
		chomp $poll_data[$i];
		($votes[$i], $options[$i]) = split(/\|/, $poll_data[$i]);
		$tmp_vote = qq~$FORM{"option$i"}~; 
		if ($multi_vote && $tmp_vote ne "") {
			$votes[$i]++;
			$novote = 1;
			if ($vote ne "") {$vote .= ",";}
			$vote .= "$tmp_vote";
		}
	}
	$tmp_vote = "$FORM{'option'}";

	if (!$multi_vote && $tmp_vote ne "") { $vote = $tmp_vote; $votes[$tmp_vote]++; $novote = 1; }

	if ($novote == 0 || $vote eq "") { &fatal_error("$polltxt{'12'}"); }
	if ($username eq "Guest" && !$guest_vote) { &fatal_error("$polltxt{'8'}"); }
	if ( $poll_locked ) {&fatal_error("$polltxt{'11'}");}

	fopen(FILE, "$datadir/$pollnum.polled");
	@polled = <FILE>;
	fclose(FILE);

	for(my $i = 0; $i < @polled; $i++) {
		($voters_ip, $voters_name, $voters_vote, $vote_time) = split(/\|/, $polled[$i]);
		chomp $voters_vote;
		   if ($username eq "Guest" && $voters_name eq "Guest" && lc $voters_ip eq lc $user_ip) { &fatal_error("$polltxt{'51'}"); }
		elsif ($username eq "Guest" && $voters_name ne "Guest" && lc $voters_ip eq lc $user_ip) { &fatal_error("$polltxt{'52'}"); }
		elsif ($username ne "Guest" && $voters_name ne "Guest" && lc $username eq lc $voters_name) { &fatal_error("$polltxt{'50'}"); }
		elsif ($username ne "Guest" && $voters_name eq "Guest" && lc $voters_ip eq lc $user_ip) { 
			foreach $oldvote (split(/\,/, $voters_vote)) {
				$votes[$oldvote]--;
			}
			$polled[$i] = "";
			last;
		}
	}
		
	fopen (FILE, ">$datadir/$pollnum.poll");
	print FILE "$poll_question\n";
	for(my $i = 0; $i < @poll_data; $i++) { print FILE "$votes[$i]|$options[$i]\n"; }
	fclose (FILE);
			
	fopen (FILE, ">$datadir/$pollnum.polled");
	print FILE "$user_ip|$username|$vote|$date\n";
	print FILE @polled;
	fclose (FILE);

	$yySetLocation = qq~$scripturl?action=portal~;

	&redirectexit;
}

sub PortalLogin2 {
	&fatal_error("$txt{'37'}") if($FORM{'username'} eq "");
	&fatal_error("$txt{'38'}") if($FORM{'passwrd'} eq "");
	$FORM{'username'} =~ s/\s/_/g;
	$username = $FORM{'username'};
	&fatal_error("$txt{'240'} $txt{'35'} $txt{'241'}") if($username !~ /^[\s0-9A-Za-z#%+,-\.:=?@^_]+$/);
	&fatal_error("$txt{'337'}") if($FORM{'cookielength'} !~ /^[0-9]+$/);

	if(-e("$memberdir/$username.dat")) {
		fopen(FILE, "$memberdir/$username.dat");
		@settings = <FILE>;
		fclose(FILE);
 		$settings[0] =~ s/[\n\r]//g;
		if($settings[0] ne "$FORM{'passwrd'}") { $username = "Guest"; &fatal_error("$txt{'39'}"); }
		$settings[0] = "$settings[0]\n";
	}
	else { $username = "Guest"; &fatal_error("$txt{'40'}"); }

	if($FORM{'cookielength'} < 1 || $FORM{'cookielength'} > 9999) { $FORM{'cookielength'} = $Cookie_Length; }
	if(!$FORM{'cookieneverexp'}) { $ck{'len'} = "\+$FORM{'cookielength'}m"; }
	else { $ck{'len'} = 'Sunday, 17-Jan-2038 00:00:00 GMT'; }
	$password = crypt("$FORM{'passwrd'}",$pwseed);

	$yySetCookies1 = cookie(-name    =>   "$cookieusername",
				-value   =>   "$username",
				-path    =>   "/",
				-expires =>   "$ck{'len'}");
	$yySetCookies2 = cookie(-name    =>   "$cookiepassword",
				-value   =>   "$password",
				-path    =>   "/",
				-expires =>   "$ck{'len'}");
	&LoadUserSettings;
	if ($maintenance && $settings[7] ne 'Administrator') {$username = 'Guest'; &fatal_error($txt{'774'});}
	&WriteLog;

	&DisplayPortal;
}

1;
