<id>
Portal SP 1.3.1 - POLL SHOWCASE PATCH
</id>

<version>
0.99
</version>

<mod info>
If you have the Showcase Polls Mod installed, apply this Mod after applying the Portal Mod.
</mod info>

<author>
Daniel Alm
</author>

<homepage>

</homepage>

<edit file>
english.lng
</edit file>

<search for>
$portal{'60'} = "No threads available.";
</search for>

<add before>
$portal{'50'} = "No poll available.";
</add before>

<search for>
\$news = The content of the newsfader in a marquee bar if allowed.<br><br>
</search for>

<replace>
\$news = The content of the newsfader in a marquee bar if allowed.<br>
\$poll = The currently showcased Poll.<br><br>
</replace>

<edit file>
Sources/Portal.pl
</edit file>

<search for>
	$uonline = qq~$guests $txt{'141'}, $numusers $txt{'142'}<BR>$users~;
</search for>

<add after>
	# Look for a showcase.poll file.
	if (-e "$datadir/showcase.poll") {
		my ($board, $viewnum);
		fopen (FILE, "$datadir/showcase.poll");
		@showdata = <FILE>;
		fclose (FILE);
		$showcasepoll = $showdata[0];
		$showcasepoll =~ s~\n~~g;
		($scboard, $viewnum) = split(/\|/, $showcasepoll);
	
		# Look for a valid poll file.
		if (-e "$datadir/$viewnum.poll") {
			$pollthread = 1;
		
			my $access = &AccessCheck($curboard, '');
			if (!($settings[7] ne "Administrator" && $access ne "granted")) {
			   unless( &BoardAccessGet($scboard) ) { $pollthread = 0; }
			}
			if ($pollthread == 1) {
				$poll .= qq~<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>~;
				$pollnum = $viewnum;
				$brdpid = $scboard;
				$scp = '';
			
				&LoadCensorList;	# Load Censor List
			
				fopen (FILE, "$datadir/$pollnum.poll");
				$poll_question = <FILE>;
				@poll_data = <FILE>;
				fclose (FILE);
				chomp $poll_question;
				($poll_question, $poll_locked, $poll_uname, $poll_name, $poll_email, $poll_date, $guest_vote, $hide_results, $multi_vote, $poll_mod, $poll_modname, $poll_comment) = split(/\|/, $poll_question);
			
				$has_voted = 0;
				if (!$guest_vote && $username eq "Guest") { $has_voted = 4; }
				else {
					fopen(FILE, "$datadir/$pollnum.polled");
					@polled = <FILE>;
					fclose(FILE);
					foreach $tmpLine (@polled){
						chomp $tmpline;
						($voters_ip, $voters_name, $voters_vote, $vote_date) = split(/\|/, $tmpLine);
						   if ($username eq "Guest" && $voters_name eq "Guest" && lc $voters_ip eq lc $user_ip) { $has_voted = 1; last; }
						elsif ($username eq "Guest" && $voters_name ne "Guest" && lc $voters_ip eq lc $user_ip) { $has_voted = 2; last; }
						elsif ($username ne "Guest" && lc $username eq lc $voters_name) { $has_voted = 3; last; }
					}
				}

				my @options;
				my @votes;
				my $totalvotes = 0;
				my $maxvote = 0;
				for(my $i = 0; $i < @poll_data; $i++) {
					chomp $poll_data[$i];
					($votes[$i], $options[$i]) = split(/\|/, $poll_data[$i]);
					$totalvotes += int($votes[$i]); 
					if (int($votes[$i]) >= $maxvote) { $maxvote = int($votes[$i]); }
				}
			
				if ($poll_locked) {
					$endedtext = qq~<tr>
			                  <td colspan="2" align="center"><font size="2"><b>$polltxt{'22'}</b></font><br><br></td>
			                </tr>~;
					$has_voted = 5;
				}
			
				# Censor the question.
				foreach (@censored) {
					($tmpa,$tmpb) = @{$_};
					$poll_question =~ s~\Q$tmpa\E~$tmpb~gi;
					$poll_comment =~ s~\Q$tmpa\E~$tmpb~gi;
				}
				if($ubbcpolls) { 
					if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; }
					$message = $poll_question;
					&DoUBBC;
					$poll_question = $message;
				}
			
				$deletevote = "";
				if ($has_voted) {
					$footer = qq~$polltxt{'17'}: $totalvotes~;
					$width = qq~~;
				} else {
					$footer = qq~<input type="submit" value="$polltxt{'18'}">~;
					$width = qq~ width="80%"~;
				}
				if ($username eq "Guest") { $deletevote = ""; }
				if ($poll_locked) { $deletevote = ""; }
			
				$poll .= qq~
			<table cellpadding="0" cellspacing="0" border="0" width="100%" align="center">
			  <tr>
			    <td>
			      <table cellpadding="3" cellspacing="1" border="0" width="100%">
			        <tr>
			          <td align="left" width="100%">
			            <table cellpadding="0" cellspacing="0" border="0" width="100%">
			              <tr>
			                <td valign="middle" align="center" width="30%">$boardpoll</td>
			                <td valign="middle" align="right" width="35%"><font size="1" color="$color{'titletext'}">$lockpoll$modifypoll$deletepoll</font></td>
			              </tr>
			            </table>
			          </td>
			        </tr>
			        <tr>
			          <td valign="top" align="center" bgcolor="$color{'windowbg2'}" class="windowbg2">
			            <form name="poll" method="post" action="$cgi;action=portalvote;num=$pollnum$scp" style="display:inline">
			              <table border="0" width="100%" cellspacing="0" cellpadding="0">
			                <tr>
			                  <td colspan="2"><font size="2"><b>$polltxt{'16'}:</b> $poll_question</font><br><br></td>
			                </tr>$endedtext<tr>
			                  <td colspan="2" align="center">~;

				if ($has_voted && $hide_results && !$poll_locked) {

					# Display Poll Hidden Message
					$poll .= qq~<font size="2">$polltxt{'47'}</font><br><font size="1">($polltxt{'48'})</font><br>~;
			
				} else {
			
					$poll .= qq~
			                     <table$width border="0" cellspacing="2" cellpadding="0">~;
			
					for($i = 0; $i < @options; $i++) {

						unless ($options[$i]) {next;};
			
						# Censor the options.
						foreach (@censored) {
							($tmpa,$tmpb) = @{$_};
							$options[$i] =~ s~\Q$tmpa\E~$tmpb~gi;
						}
						$options[$i] =~ s~[\n\r]~~g;
			
						if($ubbcpolls) {
							if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; }
							$message = $options[$i];
							&DoUBBC;
							$options[$i] = $message;
						}
			
						if ($has_voted) {
			
							# Display Poll Results
			
							$pollpercent = 0;
							$pollbar = 0;
							if ($totalvotes ne 0 && $maxvote ne 0) {
								$pollpercent = int(1000 * $votes[$i] / $totalvotes);
								$pollpercent = $pollpercent / 10;
								$pollbar = int( 150 * $votes[$i] / $maxvote);
							}
			
							$poll .= qq~
			                      <tr>
			                        <td valign="middle"><font size="2"><b>$options[$i]&nbsp;&nbsp;</b></font></td>
			                        <td valign="middle" width="250"><font size="2">&nbsp; $votes[$i] ($pollpercent%)</font></td>
			                      </tr>~;
			
						} else {
			
							# Display Poll Options
							if ($multi_vote) { $input = qq~<input type="checkbox" name="option$i" value="$i">~; } else { $input = qq~<input type="radio" name="option" value="$i">~; }

							$poll .= qq~
			                      <tr>
			                        <td valign="middle" width="25">$input</td>
			                        <td valign="middle"><font size="2"><b>$options[$i]</b></font></td>
			                      </tr>~;
			
						}
					} 
					$poll .= qq~
			                    </table>~;
				} 
			
				$poll .= qq~
			                  </td>
			                </tr><tr>
			                  <td colspan="2" align="center"><br><font size="2"><b>$footer</b></font></td>
			                </tr><tr>~;
					if ($poll_comment ne "") {
						$message = $poll_comment;
						if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
						$poll_comment = $message;
						$poll .= qq~
			                  <td colspan="2"><br><font size="2">$poll_comment</font></td>
			                </tr><tr>~;}
					$poll .= qq~
			                </tr>
			              </table>
			            </form>
			          </td>
			        </tr>
			      </table>
			    </td>
			  </tr>
			</table>~;
				}
		}
	}

	if ($pollthread == 0) { $poll = $portal{'50'}; }
</add after>

<search for>
sub PortalLogin2 {
</search for>

<add before>
sub DoPortalVote {
	$pollnum = $INFO{'num'};
	unless (-e "$datadir/$pollnum.poll") {&fatal_error("$polltxt{'14'}: $pollnum");}
	
	$novote = 0;
	$vote = "";
	fopen (FILE, "$datadir/$pollnum.poll");
	$poll_question = <FILE>;
	@poll_data = <FILE>;
	fclose (FILE);
	chomp $poll_question;
	($dummy, $poll_locked, $dummy, $dummy, $dummy, $dummy, $guest_vote, $dummy, $multi_vote, $dummy, $dummy) = split(/\|/, $poll_question);
	for(my $i = 0; $i < @poll_data; $i++) {
		chomp $poll_data[$i];
		($votes[$i], $options[$i]) = split(/\|/, $poll_data[$i]);
		$tmp_vote = qq~$FORM{"option$i"}~; 
		if ($multi_vote && $tmp_vote ne "") {
			$votes[$i]++;
			$novote = 1;
			if ($vote ne "") {$vote .= ",";}
			$vote .= "$tmp_vote";
		}
	}
	$tmp_vote = "$FORM{'option'}";

	if (!$multi_vote && $tmp_vote ne "") { $vote = $tmp_vote; $votes[$tmp_vote]++; $novote = 1; }

	if ($novote == 0 || $vote eq "") { &fatal_error("$polltxt{'12'}"); }
	if ($username eq "Guest" && !$guest_vote) { &fatal_error("$polltxt{'8'}"); }
	if ( $poll_locked ) {&fatal_error("$polltxt{'11'}");}

	fopen(FILE, "$datadir/$pollnum.polled");
	@polled = <FILE>;
	fclose(FILE);

	for(my $i = 0; $i < @polled; $i++) {
		($voters_ip, $voters_name, $voters_vote, $vote_time) = split(/\|/, $polled[$i]);
		chomp $voters_vote;
		   if ($username eq "Guest" && $voters_name eq "Guest" && lc $voters_ip eq lc $user_ip) { &fatal_error("$polltxt{'51'}"); }
		elsif ($username eq "Guest" && $voters_name ne "Guest" && lc $voters_ip eq lc $user_ip) { &fatal_error("$polltxt{'52'}"); }
		elsif ($username ne "Guest" && $voters_name ne "Guest" && lc $username eq lc $voters_name) { &fatal_error("$polltxt{'50'}"); }
		elsif ($username ne "Guest" && $voters_name eq "Guest" && lc $voters_ip eq lc $user_ip) { 
			foreach $oldvote (split(/\,/, $voters_vote)) {
				$votes[$oldvote]--;
			}
			$polled[$i] = "";
			last;
		}
	}
		
	fopen (FILE, ">$datadir/$pollnum.poll");
	print FILE "$poll_question\n";
	for(my $i = 0; $i < @poll_data; $i++) { print FILE "$votes[$i]|$options[$i]\n"; }
	fclose (FILE);
			
	fopen (FILE, ">$datadir/$pollnum.polled");
	print FILE "$user_ip|$username|$vote|$date\n";
	print FILE @polled;
	fclose (FILE);

	$yySetLocation = qq~$scripturl?action=portal~;

	&redirectexit;
}

</add before>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'portallogin2',"Portal.pl&PortalLogin2",
</search for>

<add after>
'doportalvote',"Portal.pl&DoPortalVote",
</add after>