<id>
Portal for YaBB SP 1.3.1
</id>

<version>
1.00
</version>

<mod info>
This Mod will let you integrate a portal into your board which can contain very much special information like the last 5 Threads of your board and other nice stuff ;-). It can be easily modified by the Admin center.

Installation Instructions:
1. Apply this Mod.
2. If you have got the MBCO2 Mod installed, apply portal_mbco2_patch.mod, too.
3. Change the path to template.css in the files 'portaltemplate.html' and 'portalwidetemplate.html' to the path where you want to save the template.css.
4. Upload the file 'template.css' to the path where you specified it.
5. Upload the files 'english.lng', 'portaltemplate.html', 'portalwidetemplate.html' into your main YaBB folder.
6. Upload the files 'SubList.pl', Subs.pl', 'Admin.pl', 'Portal.pl', 'ManagePortal.pl' into your Sources folder.
7. Upload the files 'Button_down.gif' and 'button_up.gif' into your YaBBImages folder.

I have integrated an example of a good portal. If you want to use it, just upload the full content of the 'Boards' folder of this ZIP file into your Boards folder.

IMPORTANT NOTE: If you are upgrading from Portal 0.98 or earlier versions, uninstall the earlier Portal Mod and rename your 'portalcolumns.txt' file in the Variables folder to 'default.portal' and move it into your Boards folder.
</mod info>

<author>
Daniel Alm
</author>

<homepage>

</homepage>

<edit file>
english.lng
</edit file>

<search for>
$txt{'796'} = "Your Instant Messages:";
</search for>

<add after>
### PORTAL MOD START ###
$portal{'00'} = "Portal Configuration";
$portal{'01'} = "Edit Portal Templates";
$portal{'02'} = "Edit Portal Pages";
$portal{'03'} = "Edit Columns";
$portal{'04'} = "Edit Boxes";
$portal{'template01'} = "Open Template";
$portal{'template02'} = qq~Here you can edit all your templates with a 'portal' at the beginning of their names.<br>
Just select one and edit it.~;
$portal{'portal01'} = "Page ID";
$portal{'portal02'} = "Modify?";
$portal{'portal03'} = "Reorder / Add Columns";
$portal{'portal04'} = "Delete Page";
$portal{'portal05'} = "ID of the new portal page";
$portal{'portal06'} = "Create Page";
$portal{'portal07'} = "The portal page";
$portal{'portal07a'} = "does exist already.";
$portal{'portal07b'} = "does not exist.";
$portal{'portal08'} = "The portal page 'default' mustn't be deleted.";
$portal{'portal09'} = "Remove Column";
$portal{'portal10'} = "Add Column";
$portal{'portal11'} = "Column ID";
$portal{'portal12'} = "The column";
$portal{'portal12a'} = "does exist already in ths page.";
$portal{'portal12b'} = "does not exist in this page.";
$portal{'portal13'} = qq~Here you can edit your portal pages.<br>
Just click on 'Reorder / Add Columns' to set which columns a page should contain or on 'Delete Page' to delete it without deleting the columns and boxes it contains.<br><br>
If you want to create a new portal page, enter its ID in the text box below and click on 'Create Page'.~;
$portal{'portal14'} = qq~Here you can reorder the columns of this portal page or add or remove some.<br>
If you want to add an existing column, select it in the dropdown box below and click on 'Add Column'.<br>
To move a column up click on the up-arrow.~;
$portal{'column01'} = "Column ID";
$portal{'column02'} = "Modify?";
$portal{'column03'} = "Reorder / Add Boxes + Edit Width";
$portal{'column04'} = "Delete Column";
$portal{'column05'} = "ID of the new column";
$portal{'column06'} = "Create Column";
$portal{'column07'} = "The column";
$portal{'column07a'} = "does exist already.";
$portal{'column07b'} = "does not exist.";
$portal{'column09'} = "Remove Box";
$portal{'column10'} = "Add Box";
$portal{'column11'} = "Box ID";
$portal{'column12'} = "The box";
$portal{'column12a'} = "does exist already in ths column.";
$portal{'column12b'} = "does not exist in this column.";
$portal{'column13'} = "Set Width";
$portal{'column14'} = "Save Width";
$portal{'column15'} = qq~Here you can edit your portal columns.<br>
Just click on 'Reorder / Add Boxes + Edit Width' to set which boxes a page should contain and to edit that column's width or on 'Delete Column' to delete it without deleting the boxes it contains.<br><br>
If you want to create a new portal column, enter its ID in the text box below and click on 'Create Column'.~;
$portal{'column16'} = qq~Here you can reorder the boxes of this portal column or add or remove some.<br>
If you want to add an existing box, select it in the dropdown box below and click on 'Add Box'.<br>
To move a box up click on the up-arrow.<br><br>
If you want to edit the width of a column, enter its new width in the text box below and click on 'Save Width'~;
$portal{'box01'} = "Box ID";
$portal{'box02'} = "Modify?";
$portal{'box03'} = "Modify Box";
$portal{'box04'} = "Delete Box";
$portal{'box05'} = "ID of the new box";
$portal{'box06'} = "Create Box";
$portal{'box07'} = "The box";
$portal{'box07a'} = "does exist already.";
$portal{'box07b'} = "does not exist.";
$portal{'box08'} = "Box Title";
$portal{'box09'} = "Box is shown on portal";
$portal{'box10'} = "Box Content";
$portal{'box11'} = qq~In this section, you can edit your Portal Boxes and add new ones. <br>
You can implement forum variables into your portal pages. This can be done by using &lt;\$varname&gt; for normal variables and &lt;yabb varname&gt; for YaBB variables (with prefix yy).<br>
There are some variables which can be used for the Portal.<br><br>
Here they are:<br>
\$uonline = List of users who are online<br>
\$login = Small login screen if user is not logged in, else nothing<br>
\$im = Number of IMs user has got if he is logged in, else nothing<br>
\$newmember = The newest member of the board.<br>
\$memcount = The number of registered users on this board.<br>
\$news = The content of the newsfader in a marquee bar if allowed.<br><br>
There are some other replacement Codes, too. Use them like they are listed here:<br>
&lt;RECENTLIST x&gt; = A list of the x last updated threads.<br>
&lt;RECENT x&gt; = A table containing a list of the x last updated threads with information like last post date, number of replies, and so on.<br>
&lt;BOARD x boardid&gt; = The first post of each of the x last updated threads of boardid, displayed in a news style. If x is -1, all threads will be shown.<br>
&lt;BOARD x boardid y&gt; = The first post of each of the x last updated threads of boardid, displayed in a news style, but showing only the first y chars in the post. If x is -1, all threads will be shown.<br>
&lt;BOARDLIST x boardid&gt; = A list of the x last updated threads of boardid.<br>
&lt;POLL x boardid&gt; = The poll with the number x. boardid specifies the board in which the poll is located.<br>
&lt;INCLUDE url&gt; = Downloads url and includes it into the portal like with SSI.<br><br>
There are some parameters for the Portal page which are given by the URL:<br>
box=boxid: Shows the box boxid only.<br>
title=number: If number is 0, the titles of the portal boxes won't be shown.<br>
template=number: If number is 1, the file 'portalwidetemplate.html' is used as Template instead of 'portaltemplate.html'. If number is 2, only the HTML code of the portal will be printed, without any Template (so you don't have tags like, html, head, body, etc.). Useful for SSI. If you enter any string instead of number, the template with filename string will be shown.<br>
If you uncheck 'Board is shown on portal?', the box won't be displayed on the normal portal page, but in the single-box display.<br><br>
An example:
If you want to make a Box which includes the list of users who are online, it's content has to look like this: &lt;\$uonline&gt;<br>
If you want to make a Box which includes a list of the last five recent thredas of your board, it's content has to look like this: &lt;RECENTLIST 5&gt;<br>
If you want this box to be displayed alone, open SCRIPTURL?action=portal;box=usersonline in your browser if the box has got the ID usersonline. The same way is to be used when you want to use the other URL parameters like template.<br><br>
If you want a column to be displayed alone, open SCRIPTURL?action=portal;column=columnname in your browser if the box has got the ID usersonline. Hidden boxes won't be shown.
~;
$portal{'box12'} = qq~Here you can edit your portal boxes.<br>
Just click on 'Modify Box' to edit that box's content and Title or on 'Delete Box to delete it.<br><br>
If you want to create a new portal box, enter its ID in the text box below and click on 'Create Box'.~;
$portal{'10'} = "Portal";
$portal{'20'} = "Posted by";
$portal{'21'} = "on";
$portal{'22'} = "Views";
$portal{'23'} = "Comments";
$portal{'24'} = "View more...";
$portal{'30'} = "No recent topics available.";
$portal{'50'} = "This poll does not exist.";
$portal{'60'} = "No threads available.";
$portal{'70'} = "No news available.";
### PORTAL MOD END ###
</add after>

<search for>
	$menusep = ' | ';
</search for>

<add after>
	$img{'portal'} = qq~<font size="1" class="imgmenu">$portal{'10'}</font>~;
</add after>

<search for>
	$menusep = ' ';
</search for>

<add after>
	$img{'portal'} = qq~<img src="$imagesdir/home.gif" alt="$portal{'10'}" border="0"> <font size="1" class="imgmenu">$portal{'10'}</font>~;
</add after>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'login',"LogInOut.pl&Login",
</search for>

<add before>
'portal',"Portal.pl&DisplayPortal",
'portallogin2',"Portal.pl&PortalLogin2",
'doportalvote',"Portal.pl&DoPortalVote",
</add before>

<search for>
'modtemp2',"AdminEdit.pl&ModifyTemplate2",
</search for>

<add after>
'modportaltemp',"ManagePortal.pl&ModifyPortalTemplate",
'modportal',"ManagePortal.pl&ModifyPortal",
'removeportalpage',"ManagePortal.pl&RemovePortalPage",
'addportalpage',"ManagePortal.pl&AddPortalPage",
'modportalpage',"ManagePortal.pl&ModifyPortalPage",
'addpagecolumn',"ManagePortal.pl&AddPageColumn",
'rempagecolumn',"ManagePortal.pl&RemovePageColumn",
'upportalcolumn',"ManagePortal.pl&UpPortalColumn",
'downportalcolumn',"ManagePortal.pl&DownPortalColumn",
'modportalcols',"ManagePortal.pl&ModifyPortalColumns", 
'removeportalcol',"ManagePortal.pl&RemoveColumn",
'addportalcol',"ManagePortal.pl&AddColumn",      
'modportalcol',"ManagePortal.pl&ModifyColumn",
'modcolumnwidth',"ManagePortal.pl&ModifyColumnWidth",
'addcolumnbox',"ManagePortal.pl&AddColumnBox",
'remcolumnbox',"ManagePortal.pl&RemoveColumnBox",
'upcolumnbox',"ManagePortal.pl&UpColumnBox",
'downcolumnbox',"ManagePortal.pl&DownColumnBox",
'modportalboxes',"ManagePortal.pl&ModifyPortalBoxes", 
'addportalbox',"ManagePortal.pl&CreateBox",
'remportalbox',"ManagePortal.pl&RemoveBox",
'modportalbox',"ManagePortal.pl&ModifyBox",
</add after>

<edit file>
Sources/Admin.pl
</edit file>

<search for>
    <table border="0" cellpadding="4" cellspacing="1" bgcolor="$color{'bordercolor'}" class="bordercolor" width="100%">
      <tr>
        <td bgcolor="$color{'catbg'}" height="19" class="catbg"><img src="$imagesdir/board.gif" alt="" border="0"> <font size="2"><b>$txt{'427'}</b></font></td>
      </tr><tr>
</search for>

<add before>
    <table border="0" cellpadding="4" cellspacing="1" bgcolor="$color{'bordercolor'}" class="bordercolor" width="100%">
      <tr>
        <td bgcolor="$color{'catbg'}" height="19" class="catbg"><img src="$imagesdir/board.gif" alt="" border="0"> <font size="2"><b>$portal{'00'}</b></font></td>
      </tr><tr>
        <td class="windowbg2"><font size="1">
        - <a href="$cgi;action=modportaltemp">$portal{'01'}</a><br>
        - <a href="$cgi;action=modportal">$portal{'02'}</a><br>
        - <a href="$cgi;action=modportalcols">$portal{'03'}</a><br>
        - <a href="$cgi;action=modportalboxes">$portal{'04'}</a><br>
        </font></td>
      </tr>
    </table><BR>
</add before>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
	$yyimages = $imagesdir;
</search for>

<add before>
	$yymenu .= qq~$menusep<a href="$scripturl?action=portal">$img{'portal'}</a>~;
</add before>